let _ = 
  Printf.printf "dim=%d highbound=%f lowbound=%f precision=%f iterations=%d seed=%d alpha=%f\n"
    Func.dim Func.highbound Func.lowbound Func.precisionx Func.iterations Func.seed Func.alpha;
  print_newline();
  Random.init Func.seed;
  let p = Array.init Func.dim
    (fun _ -> Func.lowbound +. Random.float Func.delta) in
  let (num_iter,(res,fres)) = 
    Simplex.simplex Func.f_x p Func.iterations Func.alpha Func.precisionx in
  Printf.printf "iters=%d\n" num_iter;
  Array.iter (fun x->Printf.printf "%f " x) res;
  Printf.printf "=%f\n" fres;
  flush stdout;;

  
